
#include <dht.h>
#include <Wire.h>
#include <BH1750.h>

#define DHT21_PIN 9
#define ver "0.4 BETA NODISP"


dht DHT;
BH1750 lightMeter(0x23);


const int rounds = 10;


long Vcc2, temp2, volt2, tmp;
int power_mode=1, i=0, r2=0,y=0, error_code=0;
double charge=0;
double humidity_dht_2, temperature_dht_2, humidity_dht, temperature_dht, lux_bh, lux_bh_2, mc_tmp, mc_tmp_raw;
float Vcc, Vccr, volt, temp;


void setup(){
  Serial.begin(9600);
  lightMeter.begin(BH1750_CONTINUOUS_HIGH_RES_MODE_2);
  Serial.println("STARTING:1 ;");
  delay(1000);
}

void loop() {
  Vccr = readVcc();//-75.0;
  Vcc2 = Vccr + Vcc2;
  mc_tmp_raw = mc_tmp_raw + GetTemp();
  //volt2 = analogRead(0) + volt2;    
  lux_bh_2=lux_bh_2+lightMeter.readLightLevel();
   /* switch (chk)
    {
    case DHTLIB_ERROR_CHECKSUM:
        Serial.print("Checksum error,\t");
        break;
    case DHTLIB_ERROR_TIMEOUT:
        Serial.print("Time out error,\t");
        break;
    case DHTLIB_ERROR_CONNECT:
        Serial.print("Connect error,\t");
        break;
    case DHTLIB_ERROR_ACK_L:
        Serial.print("Ack Low error,\t");
        break;
    case DHTLIB_ERROR_ACK_H:
        Serial.print("Ack High error,\t");
        break;
    default:
        Serial.print("Unknown error,\t");
        break;
    }*/
  if(i>=rounds)
  {
    int chk = DHT.read21(DHT21_PIN);
    humidity_dht_2=humidity_dht_2+DHT.humidity;
    temperature_dht_2=temperature_dht_2+DHT.temperature;
    y++;
    lux_bh=lux_bh_2/i;
    Vcc=Vcc2/i;
    mc_tmp=mc_tmp_raw/i;
    Vcc = Vcc / 1000.0;
    Vcc2=0;
    i=0;
    lux_bh_2=0;
    mc_tmp_raw=0;
  }
  if(y==4)
  {
    /*for(int z=0; z < y ; z++)
    {
		if(temperature_dht_2[z]-temperature_dht_2[z+1]>10)
		{
			error_code=2;
		}
		if(temperature_dht_2[z+1]-temperature_dht_2[z]>10)
		{
			error_code=2;
		}
    }*/
    if(error_code!=2)
    {
		humidity_dht=humidity_dht_2/y;
		temperature_dht=temperature_dht_2/y;
    }
    humidity_dht_2=0;
    temperature_dht_2=0;
    y=0;
  }
  i++;
  if(i==(rounds/2)){
    Serial.print("vcc:");
    Serial.print( Vcc );
    Serial.print(" Hum:");
    Serial.print(humidity_dht,4);
    Serial.print(" OT:");
    Serial.print(temperature_dht,4);
    Serial.print(" LUX:");
    Serial.print( lux_bh,4);
    Serial.print(" MCTMP:");
    Serial.print(mc_tmp);
    Serial.print(" ERROR:");
    Serial.print(error_code);
    Serial.println(" ;");
  }
  delay(200);
  error_code=0;
}


long readVcc() {
  // Read 1.1V reference against AVcc
  // set the reference to Vcc and the measurement to the internal 1.1V reference
  #if defined(__AVR_ATmega32U4__) || defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)
    ADMUX = _BV(REFS0) | _BV(MUX4) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);
  #elif defined (__AVR_ATtiny24__) || defined(__AVR_ATtiny44__) || defined(__AVR_ATtiny84__)
     ADMUX = _BV(MUX5) | _BV(MUX0) ;
  #else
    ADMUX = _BV(REFS0) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);
  #endif  
 
  delay(2); // Wait for Vref to settle
  ADCSRA |= _BV(ADSC); // Start conversion
  while (bit_is_set(ADCSRA,ADSC)); // measuring
 
  uint8_t low  = ADCL; // must read ADCL first - it then locks ADCH  
  uint8_t high = ADCH; // unlocks both
 
  long result = (high<<8) | low;
 
  result = 1125300L / result; // Calculate Vcc (in mV); 1125300 = 1.1*1023*1000
  return result; // Vcc in millivolts
}

double GetCharge(double voltage)
{double charge=0;
  if(voltage > 13.2 )
    return 101;
  if(voltage > 11)
  {
    voltage = voltage - 11;
    charge = (voltage / 1.2) * 100; 
  }
  return charge;
}

double GetTemp(void)
{
  unsigned int wADC;
  double t;

  // The internal temperature has to be used
  // with the internal reference of 1.1V.
  // Channel 8 can not be selected with
  // the analogRead function yet.

  // Set the internal reference and mux.
  ADMUX = (_BV(REFS1) | _BV(REFS0) | _BV(MUX3));
  ADCSRA |= _BV(ADEN);  // enable the ADC

  delay(20);            // wait for voltages to become stable.

  ADCSRA |= _BV(ADSC);  // Start the ADC

  // Detect end-of-conversion
  while (bit_is_set(ADCSRA,ADSC));

  // Reading register "ADCW" takes care of how to read ADCL and ADCH.
  wADC = ADCW;

  // The offset of 324.31 could be wrong. It is just an indication.
  t = (wADC - 324.31 ) / 1.22;

  // The returned temperature is in degrees Celsius.
  return (t);
}

long readTemp() {
  long result;
  // Read temperature sensor against 1.1V reference
  ADMUX = _BV(REFS1) | _BV(REFS0) | _BV(MUX3);
  delay(2); // Wait for Vref to settle
  ADCSRA |= _BV(ADSC); // Convert
  while (bit_is_set(ADCSRA,ADSC));
  result = ADCL;
  result |= ADCH<<8;
  result = (result - 125) * 1075;
  return result;
}
